// Uebung2 Betriebssysteme 2
// Matthias Jauernig, 2006
// Eingabe-Programm

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <stdbool.h>

#define MAXL 500
#define TIMEOUT 100

#define WLOCKEDSHM 'w'
#define QUITSHM 'q'

// Summary: Ausgabefunktion
// Speichert Daten im shared memory Bereich ab
// param adr: Adresse des Pufferbereichs
// param str: auszugebende Daten
// param anz: Anzahl der Daten in Byte
void output(char *adr, char str[], int anz)
{
	printf(".");
	//printf("adr[0] == %c\n", adr[0]);
	while(adr[0]==WLOCKEDSHM) usleep(TIMEOUT);// printf("%c", adr[0]); 		// warte auf Schreibrecht
	strcpy(adr+1, str);	// Daten in SharedMem schreiben
	adr[0]=WLOCKEDSHM;			// Bereich wieder locken bis Daten abgeholt wurden
}

void printUse(char* progname){
	printf("Benutzung: %s [-2dos | -2unix] textfile\n", progname);
}

char* readFile(){
	char* filename = (char*)malloc(100*sizeof(char));
	printf("Zu lesende Textdatei: ");
	scanf("%s", filename);
	return filename;
}

int main(int argc, char** argv){
	bool tounix = true;
	char* textfile = NULL;
	char* line = (char*)malloc(MAXL*sizeof(char));
	FILE* fp = NULL;
	int shmid, shmflag, shmsize;
	key_t shmkey;
	char* shmadr;
	
	// Kommandozeilenparameter parsen
	if(argc==2 || argc==3){
		if(argv[1][0] == '-'){
			if(strncmp(argv[1], "-2dos", 5) == 0){
				tounix = false;
				textfile = readFile();
			}
			else if(strncmp(argv[1], "-2unix", 6) == 0){
				tounix = true;
				textfile = readFile();
			}
			else{
				printUse(argv[0]);
				return 1;
			}
		}
		else if(argc==2){
			textfile = argv[1];
		}
		else{
			printUse(argv[0]);
			return 2;
		}
	}
	else if(argc==1){
		textfile = readFile();
	}
	
	// Textdatei lesen
	if((fp = fopen(textfile, "r")) == NULL){
		printf("Konnte Datei nicht zum Lesen oeffnen.\n");
		return 3;
	}	

	shmsize = MAXL;
	shmkey = ftok("ueb2_eingabe.c", 1); // Key fuer IPC anhand Filenamens erzeugen
	shmflag = IPC_CREAT | 0644;
	if((shmid=shmget(shmkey, shmsize, shmflag)) < 0){ // Shared Mem erzeugen bzw. oeffnen
		perror("Konnte Shared Memory nicht anlegen / oeffnen.");
		fclose(fp);
		return 4;
	}
	shmadr = shmat(shmid, 0, 0); // Prozess an Shared Memory anhaengen
	
	while(fgets(line, MAXL, fp) != NULL){
		//printf("> %s", line);
		if(tounix){	// DOS -> UNIX
			if(line[strlen(line)-2] == '\r'){
				line[strlen(line)-2] = '\n';
				line[strlen(line)-1] = '\0';
			}
		}
		else{		// UNIX -> DOS
			if(line[strlen(line)-1]=='\n' && line[strlen(line)-2]!='\r'){
				line[strlen(line)-1] = '\r';
				if(strlen(line)+1 < MAXL){
					line[strlen(line)] = '\n';
					line[strlen(line)+1] = '\0';
				}
				else{
					printf("Dateizeile zu lang - kann nicht in DOS-Format kopieren.\n");
					fclose(fp);
					return 4;
				}
			}
		}
		
		// Zeile in shared memory schreiben
		//printf("Jetzt vor Output...\n");
		output(shmadr, line, strlen(line)+1);
		//printf("Jetzt nach Output...\n");
	}
	printf("\n");
	fclose(fp);
	
	while(shmadr[0] == WLOCKEDSHM) usleep(TIMEOUT); // warten bis letzte Daten abgeholt wurden
	shmadr[0]=QUITSHM; // Ausgabe-Prozess signalisieren, dass wir fertig sind.
	shmdt(shmadr); // Zuordnung des shared mem zum Prozess beenden
	
	return 0;
}
